//-----------------------------------------------------------------------------
// Copyright 2018 Peter Balch
// subject to the GNU General Public License
// sends test commands to a VS1053 over SPI
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Defines and Typedefs
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// Global Constants
//-----------------------------------------------------------------------------

const long BAUDRATE  = 9600;  // Baud rate of UART in bps

//-----------------------------------------------------------------------------
// Global Variables
//-----------------------------------------------------------------------------

int  XRST  = A5;
int  SCLK  = 13;
int  DREQ  = A1;
int  XCS   = A0;

#include <SPI.h>
void setup(void)
{
  Serial.begin(9600);
  Serial.println("Midi Theremin");

  pinMode(LED_BUILTIN, OUTPUT);
  digitalWrite(LED_BUILTIN, HIGH);     delay(100);
  digitalWrite(LED_BUILTIN, LOW);      delay(100);
  digitalWrite(LED_BUILTIN, HIGH);     delay(100);
  digitalWrite(LED_BUILTIN, LOW);      delay(100);
  
  pinMode(XRST, OUTPUT);
  pinMode(MISO, OUTPUT);
  pinMode(MOSI, INPUT);
  pinMode(SCLK, OUTPUT);
  pinMode(DREQ, INPUT);
  pinMode(XCS, OUTPUT);
  
  digitalWrite(XCS, HIGH);  
  digitalWrite(XRST, LOW); 
  delay(10);                     
  digitalWrite(XRST, HIGH); 

  SPI.begin ();
  SPI.setBitOrder(MSBFIRST);
  digitalWrite(LED_BUILTIN, HIGH);     delay(100);
  digitalWrite(LED_BUILTIN, LOW);      delay(100);
  digitalWrite(LED_BUILTIN, HIGH);     delay(100);
  digitalWrite(LED_BUILTIN, LOW);      delay(100);
}

void SPItransfer(byte b)
{
  digitalWrite(XCS, LOW);
  SPI.transfer(b);
  SPI.transfer(0x00); // to read result
  digitalWrite(XCS, HIGH);
}

byte GetSerial() {
  byte b;
  while ( Serial.available() == 0 ) ;
  b = Serial.read();
  return b;  
}

//-----------------------------------------------------------------------------
// Main routines
// loop
//-----------------------------------------------------------------------------
void loop(void)
{  
  byte b;
  
  if ( Serial.available() > 0 ) 
  {
    b = GetSerial();
    SPItransfer(b);    
  }
 }
